///home/berryj/link/bin/genMethods "-g" "-t" "MDBinGraph*" "-r" "MBinGraph*" "-I" "LINK/graph/DBinGraph.h" "-y" "display_graphptr" "-m" "mark_graphptr" "-w" "free_graphptr" "-d" "graph" "-f" "__mDBinGraph_" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/DBinGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graphptr(SCM, SCM, int);
void mark_graphptr(SCM);
void free_graphptr(SCM);

typedef MDBinGraph* _MDBinGraph_;

#define _MDBinGraph_DATA(x) ((MDBinGraph**) (EXTDATA(x)))
#define _MDBinGraph_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MDBinGraph* >::type))
#define _MDBinGraph_ISNT_DATA(x) (!_MDBinGraph_IS_DATA(x))

#define _MDBinGraph_CXX_DATA(x) (*(MDBinGraph**) (EXTDATA(VAL(x))))
#define _MDBinGraph_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MDBinGraph* >::type))
#define _MDBinGraph_CXX_ISNT_DATA(x) (!_MDBinGraph_CXX_IS_DATA(x))


static SCM is_MDBinGraph_(SCM i)
{
	if (_MDBinGraph_CXX_IS_DATA(i))
		return Truth;
	return Ntruth;
}

PRIMITIVE STk_init___mDBinGraph_()
{
	Wrapper<_MDBinGraph_>::type = STk_new_CXXwrapper_id(
			Wrapper<_MDBinGraph_>::name, 
			Wrapper<MBinGraph* >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graphptr,
			(void (*)(SCM x))mark_graphptr,
			(void (*)(SCM x))free_graphptr);
	Tcl_InitHashTable(&Register<_MDBinGraph_>::objTable, TCL_ONE_WORD_KEYS);
	STk_add_new_cpp_primitive("MDBinGraph?", tc_subr_1,
	(PRIMITIVE (*)(...))  is_MDBinGraph_);
	return UNDEFINED;
}

void genExtra__mDBinGraph_Methods(void);

PRIMITIVE STk_init_methods___mDBinGraph_()
{
	genExtra__mDBinGraph_Methods();
	return UNDEFINED;
}
